theory Tmp imports MatrixCarrier
begin

lemma assumes "\<And> x  y :: rat. (x,y) \<in> set xys \<Longrightarrow> x > y"
  shows "\<exists> \<delta>. \<forall> x y. (x,y) \<in> set xys \<longrightarrow> rat_gt \<delta> x y"
proof -
  from assms have "\<exists> \<delta> > 0. \<forall> x y. (x,y) \<in> set xys \<longrightarrow> rat_gt \<delta> x y"
  proof (induct xys)
    case Nil
    show ?case by (rule exI[of _ 1], auto)
  next
    case (Cons xy xys)
    show ?case
    proof (cases xy)
      case (Pair x y)
      with Cons have "x > y" by auto
      then obtain d1 where "d1 = x - y" and d1pos: "d1 > 0" and "d1 \<le> x - y" by auto
      hence xy: "rat_gt d1 x y" unfolding rat_gt_def positive_delta_def by auto
      from Cons obtain d2 where d2pos: "d2 > 0" and xys: "\<forall> x y. (x, y) \<in> set xys \<longrightarrow> rat_gt d2 x y" by auto
      obtain d where d: "d = min d1 d2" by auto
      with d1pos d2pos xy have dpos: "d > 0" and "rat_gt d x y" unfolding rat_gt_def positive_delta_def by auto
      with xys d Pair have "\<forall> x y. (x,y) \<in> set (xy # xys) \<longrightarrow> rat_gt d x y" unfolding rat_gt_def positive_delta_def by force
      with dpos show ?thesis by auto 
    qed
  qed
  thus ?thesis by auto
qed

