header {* CetaSimplifier *}
(*
theory Ceta
export_code certifyProof parseCertProblem in SML module_name Ceta file "generated/SML/Ceta.ML" (takes around 20 seconds)
*)
theory CetaSimplifier
imports Ceta
uses ("generated/SML/Ceta.ML")
begin

use "generated/SML/Ceta.ML" (* takes around 15 seconds *)

ML {*
  val input = File.read (Path.explode "~/rewriting/examples/rational_matrix.proof.xml") |> String.explode
  val parse = Ceta.parseCertProblem
  val ceta = Ceta.certifyProof
  val res = (parse input, ceta input)
*} (* takes around 0.1 seconds *)


ML {*
  fun inp x = (* "some_prover " ^ x
            |> bash_output
            |> fst *)
            File.read (Path.explode x)
            |> HOLogic.mk_string
(*            |> (fn t => @{term certifyProof} $ t)    *)
            |> (fn t => @{term parseCertProblem} $ t)   
            |> Eval.eval_term @{theory}; 
    fun import_term file  =  snd o Local_Theory.define ((@{binding my_term}, NoSyn), ((@{binding my_term_def}, []), inp file) )
*}

local_setup {*
  timeit (fn _ => import_term "~/rewriting/examples/rational_matrix.proof.xml" (* around 9 seconds *) )
  (* changing this to rational_matrix.proof.xml (the larger proof) \<longrightarrow> abort after 1 hour *)
*}
term my_term
thm my_term_def




ML {*
structure CetaRules = Named_Thms
  (val name = "ceta"
   val description = "Theorems for execution of CeTA")
*}

setup {* CetaRules.setup *}


lemmas ceta_congs = sum.weak_case_cong if_weak_cong list.weak_case_cong nat.weak_case_cong

lemma ceta_list: shows
   [ceta]: "length [] = 0" and [ceta]: "\<And> x xs. length (x # xs) = Suc (length xs)" 
  and [ceta]: "null []" and [ceta]: "\<And> x xy. \<not> (null (x # xs))" 
  and [ceta]: "\<And> x xy. (x # xs) \<noteq> []" by auto

lemmas xml_parser_simps = wspace_def letters_def dquote_def splitter_fun.simps splitter_def trim.simps bind_def 
  update_tokens_def get_tokens_def set_tokens_def quote_def expecting_def eoi.simps oneof_aux.simps oneof_def many.simps
  manyof_def spaces_def scan_upto.simps parse_name_def parse_text_def parse_attribute_value_def
  parse_attributes.simps parse_nodes.simps parse_node_def parse_header.simps remove_comments_aux.simps remove_comments_def
  parse_doc_def doc_of_string_def debug.simps nat_number take.simps
  sum.cases list.cases nat.cases Nat.nat.simps  add_Suc member_simps
  eq_nat_number_of neg_number_of_Bit0 neg_number_of_Bit1 numeral_1_eq_1 not_neg_1 numeral_0_eq_0 not_neg_0 add.left_neutral
  One_nat_def
  if_True if_False map.simps zip.simps Error_Monad.bind_def
  Let_def list.inject char.inject nibble.simps HOL.simp_thms newline_def drop.simps shows_between_def newline_def
  shows_prec_list_def shows_list_list_def shows_prec_char_def shows_list_char_def split_def fst_conv snd_conv id_def
  List.append.simps shows_string_def shows_list_aux_def shows_list_gen_def shows_sep.simps

declare xml_parser_simps[ceta]

lemma "(if (id x) then id 1 else id 2) = id 3"
proof (tactic {* simp_tac (HOL_basic_ss addsimps @{thms ceta} addcongs @{thms ceta_congs}) 1 *})
oops


(* ceta-simps now suffice to simplify doc_of_string *)

definition test_term where  "test_term == doc_of_string ''<?xml version=\"1.0\"?><certificationProblem><foo/></certificationProblem>''" 
(* definition test_term where  "test_term == doc_of_string ''<ba><fo/></ba>''"*)
term parseCertProblem
term doc_of_string

lemma "test_term = x" proof (simp only: ceta test_term_def cong: ceta_congs)
oops
ML {*
  op ::
*}
ML {*
  val t = Eval.eval_term @{theory} @{term test_term} |> cterm_of @{theory}; 
  val my_simpset = HOL_basic_ss addsimps (@{thm test_term_def} :: @{thms ceta}) addcongs @{thms ceta_congs};
  val s = timeit (fn () => Simplifier.rewrite my_simpset @{cterm test_term})
*}
ML {*
  fun inp x = (* "some_prover " ^ x
            |> bash_output
            |> fst *)
            File.read (Path.explode x)
            |> HOLogic.mk_string
            |> (fn t => @{term certifyProof} $ t)    
(*            |> (fn t => @{term doc_of_string} $ t)   *)
(*            |> (fn t => @{term parseCertProblem} $ t)   *)
            |> Eval.eval_term @{theory}; 
(*            |> cterm_of @{theory} |> Simplifier.rewrite my_simpset |> prop_of |> (fn (_ $ y) => y);  *)
    fun import_term file  =  snd o Local_Theory.define ((@{binding my_term}, NoSyn), ((@{binding my_term_def}, []), inp file) )
*}

(*thm if_weak_cong
lemma "(if x then id 1 else id 2) = id 3" proof (simp split del: split_if)
*)

local_setup {*
  timeit (fn _ => import_term "~/rewriting/examples/rational.proof.xml" (* "test.xml" *) )
*}
term my_term
thm my_term_def




end

